#define PAGE_SIZE 4096
#define BANK_SIZE (PAGE_SIZE-sizeof(void*))/sizeof(T)

//!  
template<typename T>
class Allocator{
	union item_st{
		item_st *next;
		T data;
	};
	struct bank_st{ 
		item_st array[BANK_SIZE];
		bank_st *next;
	};
	bank_st *list;	//!<   
	item_st *free;	//!<   
	void NewBank();	//!<    
public:
	Allocator();
	~Allocator();
	T *New();		//!<   
	void Free(T*);	//!<  
	void Clear();	//!<   
};



template<typename T>Allocator<T>::Allocator()
{
	free=0;	list=0;
}


template<typename T>Allocator<T>::~Allocator()
{
	Clear();
}


template<typename T>void Allocator<T>::NewBank()
{
	bank_st *bank=new bank_st;
	bank->next=list; list=bank;
	int n=BANK_SIZE;
	while(n) Free(&bank->array[--n].data);
}


template<typename T>void Allocator<T>::Clear()
{
	bank_st *temp;
	while(list) {
		temp=list;
		list=list->next;		
		delete temp;
	}
	free=0;
}


//!    
template<typename T>T* Allocator<T>::New()
{
	if(!free) NewBank();
	item_st *res=free; free=free->next;
	return &res->data;
}

template<typename T>void Allocator<T>::Free(T* data)
{
	item_st *item=(item_st*)data;
	item->next=free;
	free=item;
}



